SystemOrganization addCategory: #CopyHierarchy!

!ClassDescription methodsFor: '*CopyHierarchy' stamp: 'hjo 4/20/2012 10:18'!
definitionWithSuperclass
	"Answer a String that defines the receiver."

	| aStream |
	aStream := (String new: 800) writeStream.
	aStream nextPutAll: self kindOfSubclass;
			store: self name.
	(self hasTraitComposition and: [self traitComposition notEmpty]) ifTrue: [
		aStream cr; tab; nextPutAll: 'uses: ';
			nextPutAll: self traitCompositionString].
	aStream cr; tab; nextPutAll: 'instanceVariableNames: ';
			store: self instanceVariablesString.
	aStream cr; tab; nextPutAll: 'classVariableNames: ';
			store: self classVariablesString.
	aStream cr; tab; nextPutAll: 'poolDictionaries: ';
			store: self sharedPoolsString.
	aStream cr; tab; nextPutAll: 'category: ';
			store: self category asString.

	superclass ifNil: [ 
		aStream nextPutAll: '.'; cr.
		aStream nextPutAll: self name.
		aStream space; nextPutAll: 'superclass: nil'. ].

	^ aStream contents! !

Object subclass: #CopyHierarchy
	instanceVariableNames: 'classNamePrefix classCategoryForDupedClass subclassesOfClassToDup classToDup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CopyHierarchy'!

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 10:31'!
dupClass: aClass

	| t |
	t := aClass duplicateClassWithNewName: (classNamePrefix, aClass name) asSymbol.
	t category: classCategoryForDupedClass.
	

	 ! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 10:02'!
dupLineSegment

	self dupClass: LineSegment.
	

	 ! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 10:26'!
moveClassNamed: classSymbol toSuper: superClassSymbol

	Compiler evaluate: (superClassSymbol ,  (Smalltalk at: classSymbol) definitionWithSuperclass).! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 10:34'!
moveLeavesToDupedSuper

	subclassesOfClassToDup do: [:each| 
		self moveClassNamed: ((classNamePrefix, each name) asSymbol) toSuper: #DaliotLineSegment.
		].! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 10:37'!
run
	classNamePrefix := 'Daliot'.
	classCategoryForDupedClass := 'DuppyDup'.
	classToDup := LineSegment.
	subclassesOfClassToDup := classToDup subclasses.
	subclassesOfClassToDup do: [ :each | self dupClass: each ].
	self dupLineSegment.
	self moveLeavesToDupedSuper! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 10:01'!
tearDown

	self class environment organization removeSystemCategory: classCategoryForDupedClass.! !
